/*
 * CS356 Project 01 -- Elevator Simulator
 *
 * ElevatorController Class Specification
 */

#ifndef ELEVATORCONTROLLER_HPP
#define ELEVATORCONTROLLER_HPP

#include "direction.hpp"
#include "elevator.hpp"

#include <iostream>
#include <cstdlib>
#include <ctime>
#include <climits>
#include <vector>

typedef std::vector<Elevator> ElevatorList;

/* Forward-declare Exceptions */
class bad_elevator { };
class bad_floor { };

class ElevatorController
{
	public:
		ElevatorController (int floors, int elevators);

		void call_elevator_to (int floor, Direction direction);
		void elevator_request (int elevator_number, int floor);
		void move_elevators ();

	private:
		int number_of_floors_;
		int number_of_elevators_;

		ElevatorList elevators_;

};

/* vim: set ts=4 sts=4 sw=4 noet tw=112: */

#endif /* ELEVATORCONTROLLER_HPP */
