#include "main.hpp"
#include "elevatorgui.hpp"

static ElevatorGUI *thegui = NULL;

int main (int argc, char *argv[])
{
	int floors = 7;
	int elevators = 3;

//#define USE_STATIC_FLOORS 1
#ifndef USE_STATIC_FLOORS
	do
	{
		std::cout << "Enter the number of floors to use [2-10]: ";
		std::cin >> floors;

		if (floors < 2 || floors > 10)
		{
			std::cout << "You entered: " << floors
					  << " which is outside the acceptable range." << std::endl;
			std::cout << "Please try again..." << std::endl << std::endl;
		}
		else
		{
			// Good input, leave now
			break;
		}
	} while (true);

	do
	{
		std::cout << "Enter the number of elevators to use [1-5]: ";
		std::cin >> elevators;

		if (elevators < 1 || elevators > 5)
		{
			std::cout << "You entered: " << elevators
					  << " which is outside the acceptable range." << std::endl;
			std::cout << "Please try again..." << std::endl << std::endl;
		}
		else
		{
			// Good input, leave now
			break;
		}
	} while (true);
#endif

	// Start GTK
	Gtk::Main app(argc, argv);

	// Start the GUI
	ElevatorGUI eg(floors, elevators);
	thegui = &eg;

	// Show the GUI
	eg.show ();

	// Run it!
	Gtk::Main::run (eg);

	return 0;
}


void gui_update_position_label (int elevator, float new_position, Direction direction)
{
	thegui->gui_update_position_label (elevator, new_position, direction);
}

void gui_unpress_call_button (int floor, Direction direction)
{
	thegui->gui_unpress_call_button (floor, direction);
}

void gui_unpress_request_button (int elevator, int floor)
{
	thegui->gui_unpress_request_button (elevator, floor);
}

void gui_open_door (int elevator, int floor)
{
	thegui->gui_open_door (elevator, floor);
}

void gui_close_door (int elevator, int floor)
{
	thegui->gui_close_door (elevator, floor);
}

/* vim: set ts=4 sts=4 sw=4 noet tw=112: */
